
Public Support - Support Request #11918

License usage of Qt in combination with ADTF

2020-08-14 10:34 - hidden

Status: Closed   

Priority: Normal   

Category:    

Customer: CARIAD Product Issue

Numbers:

 

Department: D/CS-G33 Affected Products: ADTF 3.8.0

Requester's Priority: Normal Platform:  

Support Level: 2nd Level Topic: ADTF::License

Resolution: Solved Issue FAQ Links:  

Description

Supportanfrage

Deckt die bei Digitalwerk intern genutzte (und vermutlich kommerzielle) Qt5-SDK-Lizenz auch Kunden wie AUDI und zukünftig

CarSoftware.org mit ab? Ich vermute, daß Kunden, die eigene Filter mit Qt5 entwickeln wollen, sich eine eigene kommerz. Lizenz

besorgen müssen. Ist as so richtig?

Lösung

Es hat sich nichts bzgl. Qt von ADTF 2.x auf ADTF 3.x geändert außer die Version.

Beide ADTF Major Versionen verwenden Qt in der Open Source Variante und wir liefern auch alle Abhängigkeiten, welche unter der

LGPL stehen und filtern die "bösen" GPL Komponenten heraus.

Solange du also diese Komponenten verwendest, bist du sauber.

Siehe:

https://support.digitalwerk.net/adtf/v3/adtf_html/page_qt.html

https://support.digitalwerk.net/adtf/v3/adtf_html/page_external_dependencies.html

https://support.digitalwerk.net/adtf/v3/adtf_html/page_license_information.html

Du musst nur etwas mit dem Wording aufpassen.

Natürlich benötigst du immer eine Qt Lizenz, in diesem Fall aber die Open Source und nicht die kommerzielle Variante.

Du könntest auch gar nicht die kommerzielle Lizenz nutzen, weil das Qt unterbindet (die beiden Varianten sind inkompatibel).

Hierzu sind wir mit Qt derzeit in Klärung und ziehen ggf. auch in Erwägung, Qt kommerziell einzusetzen unter dem Hintergrund, das

Qt sein LTS Modell geändert hat.

Vielleicht hast du das mitbekommen, das ist aber noch in Klärung und am Ende muss definiert sein, was wie zu verwenden ist, ohne

Nachteil für ADTF und die Anwender.

Grundsätzlich zur Lizenzthematik:

Qt oder ADTF machen hier nichts besonderes, du musst immer die Lizenzbedindungen erfüllen, auch beim Einsatz von 3rd Party

Abhängigkeiten, hier kann dir ADTF nicht helfen.

Solange du aber immer ADTF so wie es ist verwendest, wirst du keine Probleme haben.

Trotzdem solltest du bei Produkten die ihr vertreibt natürlich eine Open Source und rechtliche Prüfung in House absegnen.

Du brauchst eine ADTF und eine Qt Lizenz, welche aber Open Source ist.

Das war und ist so in ADTF 2.x als auch in ADTF 3.x.

Werden für ADTF 3 QT Lizenzen für die Entwicklung benötigt?

 Qt gibt es Open Source und Kommerziell, theoretisch sogar in einer "Reseller" Variante, was aber auch Kommerziell ist.

ADTF verwendet Qt Open Source und beschränkt sich dabei auf die LGPL Anteile, da ansonsten der Quellcode mit GPL infiziert wird

(z.B. QtCharts) und demnach ADTF unter eine GPL kompatible Open Source Lizenz gestellt werden müsste.

Hinweis am Rande: Das ist der Grund, warum die DAT GUI Tools ein gesondertes Open Source Produkt sind

Noch ein allgemeiner Hinweis: Ihr könnt natürlich GPL Komponenten einsetzen für interne Zwecke. Was ihr aber z.B. nicht dürft, sind

ADTF Komponenten zu vertreiben, die GPL Abhängkeit haben (egal ob ihr euren Code offen legt oder nicht), denn die "böse" GPL

hat auch einen combined work Absatz, und demnach müsste der Launcher und Core Objects (als Teile der gemeinsamen
Plugin-Instanz) auch Open Source sein. Kurz: ADTF und GPL Lizenz verträgt sich nicht. Es gibt aber Bestrebungen, Teile von ADTF

offen zu legen oder kommerzielle Abhängigkeiten zu nutzen. Das betrifft nicht nur Qt, sondern alle GPL Libraries. das nur am Rande,

das sollte euch normalerweise eure Rechtsabteilung auch sagen :-) Hat aber weniger was mit dem Thema des Tickets zu tun

Wird die QT Lizenz generell benötigt wenn Filter / Services kompiliert werden oder nur wenn QT als Oberflächenelement

eingebunden wird?

 Das ist egal. Sobald du in deinen Source Code Open Source Abhängigkeiten verwendest, hast du dessen Lizenz zu beachten, in

den meisten Fällen musst du das einfach angeben.

Wenn du kommerzielle Lizenzen nutzt, dann nicht (was aber wie gesagt im Falle von Qt hier ausscheidet, zumindest aktuell, wir sind

wie gesagt in Klärung, weil der Lizenztext von Qt das nicht sauber abbildet, wenn man ein Framework schafft (=ADTF), was Qt

kommerziell verwendet und der Anwender ggf. nur Open Source. Das muss unser Meinung nach möglich sein!

Gibt es weitere zusätzliche Lizenzen (im Unterschied zu ADTF2) die für das ADTF 3 Grundsystem noch benötigt werden.

 Nein, du kannst ADTF mit der ADTF Lizenz verwenden, hier sind auch die Standard Toolboxen dabei.

Wenn du Abhängigkeiten in deinen Filtern hast, egal ob bereits von ADTF verwendet (z.B. Qt, OSG, SDL, OpenGL) oder nicht (z.B.

OpenCV o.ä.), hast du dafür Sorge zu tragen, die Lizenzbedingungen nicht zu erfüllen. Beim Einsatz kommerzieller Software

bedeutet das zumeist Geld, bei Open Source eine Erwähnung oder Offenlegung.

ADTF nutzt Qt5 Open Source (aber ohne GPL-Bestandteile), liefert aber nur die Runtime-Libs mit

 Ja, ADTF liefert alle LGPL Anteile, die zur Laufzeit gebraucht werden (können) und "bereinigt" das Package mit "bösen" GPL Anteil

zu eurem eigenen Schutz

Wir benötigen das Qt5 Open Source SDK, wenn wir anspruchsvolle Qt-Oberflächen bauen wollen

 Das Wort anspruchsvoll kannst du streichen: Du benötigst ein QT Developer Package wenn du eigenen Qt Elemente in ADTF

programmieren möchtest.

Die Open-Source-Variante erfordert beim Installieren eine Bestätigung (rot unterstrichen, siehe unten). Der Satz "not for any

company" hört sich ziemlich klar an.

 Genau, das darfst du nicht anhaken.

Wegen der enthaltenen GPL-Bestandteile?

 Nein, auch eine Firma darf GPL Anteile nutzen, muss dann aber den Code seines eigenen Produkets offenlegen bzw. unter eine

GPL kompatible Lizenz stellen

Muß man sich eine eigene GPL-freie Distribution zusammenstellen?

 Nein musst du nicht, du kannst das Laufzeit Paket von ADTF nutzen, das ist wie gesagt schon sauber und auch AUDI

Rechtsabteilung geprüft.

Oder verteilt ihr solch eine?

Gibt es eine passendere offizielle Distribution?

 Du meinst ein Devloper Package ohne GPL ?

Das gibt es so nicht...

Du kannst bei der Installation QtCharts und QtDataVisualization sowie sämtliche Tools weglassen, entscheidend ist aber nicht was

du nutzt sonst was du lieferst (siehe unser Paket).

Anders gesagt: Du kannst das volle Paket nehmen verwendest aber nur die "guten" Anteile. Wenn du nichts zusätzlich installierst ins

ADTF Qt Runtime Package, dann ist alles gut.

Du findest ein Paket bei uns im Artifactory -> Siehe https://support.digitalwerk.net/adtf/v3/adtf_html/page_qt.html bzw. 

https://support.digitalwerk.net/adtf/v3/adtf_html/page_external_dependencies.html

Das ist aber wie gesagt vollständig, es obliegt dir was du daraus verwendest (es geht wie gesagt nur um Qt5Charts und

Qt5DataVisualization, diese sind GPL). Alles andere wie Tools und co sind für euch nicht relevant.
History

#1 - 2020-08-14 13:21 - hidden

- Project changed from 11 to 30

- Status changed from New to Customer Feedback Required

- Topic set to ADTF::License

Hallo Patrick,

folgende Informationen sind verfügbar:

Es hat sich nichts bzgl. Qt von ADTF 2.x auf ADTF 3.x geändert außer die Version.

Beide ADTF Major Versionen verwenden Qt in der Open Source Variante und wir liefern auch alle Abhängigkeiten, welche unter der LGPL stehen

und filtern die "bösen" GPL Komponenten heraus.

Solange du also diese Komponenten verwendest, bist du sauber.

Siehe:

https://support.digitalwerk.net/adtf/v3/adtf_html/page_qt.html

    https://support.digitalwerk.net/adtf/v3/adtf_html/page_external_dependencies.html

    https://support.digitalwerk.net/adtf/v3/adtf_html/page_license_information.html

 Du musst nur etwas mit dem Wording aufpassen.

Natürlich benötigst du immer eine Qt Lizenz, in diesem Fall aber die Open Source und nicht die kommerzielle Variante.

Du könntest auch gar nicht die kommerzielle Lizenz nutzen, weil das Qt unterbindet (die beiden Varianten sind inkompatibel).

Hierzu sind wir mit Qt derzeit in Klärung und ziehen ggf. auch in Erwägung, Qt kommerziell einzusetzen unter dem Hintergrund, das Qt sein LTS

Modell geändert hat.

Vielleicht hast du das mitbekommen, das ist aber noch in Klärung und am Ende muss definiert sein, was wie zu verwenden ist, ohne Nachteil für

ADTF und die Anwender.

Grundsätzlich zur Lizenzthematik:

Qt oder ADTF machen hier nichts besonderes, du musst immer die Lizenzbedindungen erfüllen, auch beim Einsatz von 3rd Party Abhängigkeiten,

hier kann dir ADTF nicht helfen.

Solange du aber immer ADTF so wie es ist verwendest, wirst du keine Probleme haben.

Trotzdem solltest du bei Produkten die ihr vertreibt natürlich eine Open Source und rechtliche Prüfung in House absegnen.

Du brauchst eine ADTF und eine Qt Lizenz, welche aber Open Source ist.

Das war und ist so in ADTF 2.x als auch in ADTF 3.x.

Werden für ADTF 3 QT Lizenzen für die Entwicklung benötigt?

 Qt gibt es Open Source und Kommerziell, theoretisch sogar in einer "Reseller" Variante, was aber auch Kommerziell ist.

ADTF verwendet Qt Open Source und beschränkt sich dabei auf die LGPL Anteile, da ansonsten der Quellcode mit GPL infiziert wird (z.B. QtCharts)

und demnach ADTF unter eine GPL kompatible Open Source Lizenz gestellt werden müsste.

Hinweis am Rande: Das ist der Grund, warum die DAT GUI Tools ein gesondertes Open Source Produkt sind

Noch ein allgemeiner Hinweis: Ihr könnt natürlich GPL Komponenten einsetzen für interne Zwecke. Was ihr aber z.B. nicht dürft, sind ADTF

Komponenten zu vertreiben, die GPL Abhängkeit haben (egal ob ihr euren Code offen legt oder nicht), denn die "böse" GPL hat auch einen combined

work Absatz, und demnach müsste der Launcher und Core Objects (als Teile der gemeinsamen Plugin-Instanz) auch Open Source sein. Kurz: ADTF

und GPL Lizenz verträgt sich nicht. Es gibt aber Bestrebungen, Teile von ADTF offen zu legen oder kommerzielle Abhängigkeiten zu nutzen. Das

betrifft nicht nur Qt, sondern alle GPL Libraries. das nur am Rande, das sollte euch normalerweise eure Rechtsabteilung auch sagen :-) Hat aber

weniger was mit dem Thema des Tickets zu tun

Wird die QT Lizenz generell benötigt wenn Filter / Services kompiliert werden oder nur wenn QT als Oberflächenelement eingebunden wird?

 Das ist egal. Sobald du in deinen Source Code Open Source Abhängigkeiten verwendest, hast du dessen Lizenz zu beachten, in den meisten Fällen

musst du das einfach angeben.

Wenn du kommerzielle Lizenzen nutzt, dann nicht (was aber wie gesagt im Falle von Qt hier ausscheidet, zumindest aktuell, wir sind wie gesagt in

Klärung, weil der Lizenztext von Qt das nicht sauber abbildet, wenn man ein Framework schafft (=ADTF), was Qt kommerziell verwendet und der

Anwender ggf. nur Open Source. Das muss unser Meinung nach möglich sein!

Gibt es weitere zusätzliche Lizenzen (im Unterschied zu ADTF2) die für das ADTF 3 Grundsystem noch benötigt werden.

 Nein, du kannst ADTF mit der ADTF Lizenz verwenden, hier sind auch die Standard Toolboxen dabei.

Wenn du Abhängigkeiten in deinen Filtern hast, egal ob bereits von ADTF verwendet (z.B. Qt, OSG, SDL, OpenGL) oder nicht (z.B. OpenCV o.ä.),

hast du dafür Sorge zu tragen, die Lizenzbedingungen nicht zu erfüllen. Beim Einsatz kommerzieller Software bedeutet das zumeist Geld, bei Open

Source eine Erwähnung oder Offenlegung.

@Florian gibt es hierzu Ergänzungen / Korrekturen bzgl analoger Aussage für CarSoftware.org?
#2 - 2020-08-14 15:53 - hidden

- File qt_licence.png added

Also ich nehme mal mit:

ADTF nutzt Qt5 Open Source (aber ohne GPL-Bestandteile), liefert aber nur die Runtime-Libs mit

Wir benötigen das Qt5 Open Source SDK, wenn wir anspruchsvolle Qt-Oberflächen bauen wollen

Die Open-Source-Variante erfordert beim Installieren eine Bestätigung (rot unterstrichen, siehe unten). Der Satz "not for any company" hört sich

ziemlich klar an. Wegen der enthaltenen GPL-Bestandteile? Muß man sich eine eigene GPL-freie Distribution zusammenstellen? Oder verteilt ihr

solch eine? Gibt es eine passendere offizielle Distribution?

 qt_licence.png 

#3 - 2020-08-18 10:52 - hidden

Hi Patrick,

ADTF nutzt Qt5 Open Source (aber ohne GPL-Bestandteile), liefert aber nur die Runtime-Libs mit

 Ja, ADTF liefert alle LGPL Anteile, die zur Laufzeit gebraucht werden (können) und "bereinigt" das Package mit "bösen" GPL Anteil zu eurem

eigenen Schutz

Wir benötigen das Qt5 Open Source SDK, wenn wir anspruchsvolle Qt-Oberflächen bauen wollen

 Das Wort anspruchsvoll kannst du streichen: Du benötigst ein QT Developer Package wenn du eigenen Qt Elemente in ADTF programmieren

möchtest.

Die Open-Source-Variante erfordert beim Installieren eine Bestätigung (rot unterstrichen, siehe unten). Der Satz "not for any company" hört sich

ziemlich klar an.

 Genau, das darfst du nicht anhaken.

Wegen der enthaltenen GPL-Bestandteile?

 Nein, auch eine Firma darf GPL Anteile nutzen, muss dann aber den Code seines eigenen Produkets offenlegen bzw. unter eine GPL kompatible

Lizenz stellen

Muß man sich eine eigene GPL-freie Distribution zusammenstellen?

 Nein musst du nicht, du kannst das Laufzeit Paket von ADTF nutzen, das ist wie gesagt schon sauber und auch AUDI Rechtsabteilung geprüft.

Oder verteilt ihr solch eine?

Gibt es eine passendere offizielle Distribution?

 Du meinst ein Devloper Package ohne GPL ?

Das gibt es so nicht...

Du kannst bei der Installation QtCharts und QtDataVisualization sowie sämtliche Tools weglassen, entscheidend ist aber nicht was du nutzt sonst

was du lieferst (siehe unser Paket).

Anders gesagt: Du kannst das volle Paket nehmen verwendest aber nur die "guten" Anteile. Wenn du nichts zusätzlich installierst ins ADTF Qt

Runtime Package, dann ist alles gut.

Du findest ein Paket bei uns im Artifactory -> Siehe https://support.digitalwerk.net/adtf/v3/adtf_html/page_qt.html bzw. 

https://support.digitalwerk.net/adtf/v3/adtf_html/page_external_dependencies.html

Das ist aber wie gesagt vollständig, es obliegt dir was du daraus verwendest (es geht wie gesagt nur um Qt5Charts und Qt5DataVisualization, diese

sind GPL). Alles andere wie Tools und co sind für euch nicht relevant.

#4 - 2020-08-25 08:54 - hidden

- Project changed from 30 to Public Support

- Subject changed from Lizenz Qt5 to License usage of Qt in combination with ADTF

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Private changed from Yes to No

- Resolution set to Solved Issue
Ich schließe das Ticket ab, ich denke das passt an der Stelle.

Sollte es noch vereinzelt Nachfragen geben, entweder Folgeticket oder gerne auch auf kurzen Wege über das Projekt, die grundlegenden Fragen

denke ich sind aber geklärt.

#6 - 2020-10-06 10:27 - hidden

- Status changed from To Be Closed to Closed

#8 - 2021-07-26 13:24 - hidden

- Customer changed from Car.SW Org. to CARIAD
